;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cells; -*-
#|

    Hunchncells -- Cells, Parenscript, and HTML

Copyright (C) 2008 by Andy Chambers

This library is free software; you can redistribute it and/or
modify it under the terms of the Lisp Lesser GNU Public License
 (http://opensource.franz.com/preamble.html), known as the LLGPL.

This library is distributed  WITHOUT ANY WARRANTY; without even 
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the Lisp Lesser GNU Public License for more details.

|#

(in-package :hunchncells)

(defmodel web-apropos (page)
  ((term :initarg :term :accessor term :initform nil))
  (:default-initargs
      :term (c? (param? "s"))
    :title "Lisp Apropos"
    :style "style.css"
    :kids (c? (the-kids
	       (mk-div ()
		 (mk-form (:action "post")
		   (mk-label (:for "s")
		     (mk-text "Apropos: "))
		   (mk-input (:name "s" :id "s"
				    :-type "text"
				    :value (c? (term (u^ web-apropos)))))

		   (mk-label (:for "d")
		     (mk-text "Describe"))
		   (mk-textarea (:name "d" :id "d"))))))))

(defun test-page (path resource-class)
  (lambda (request)
    (start-session)
    (let ((root (or (session-value 'root)
		   (not (print "creating new web-app..."))
		   (mk-web-app (:prefix path
                                :request (c-in request))
		     (make-instance
		      resource-class
		      :fm-parent *parent*)))))
      (setf (session-value 'root) root)
      (setf (request root) request)
      (handler root))))



(defun reload ()
  (cells-reset)
  (reset-sessions)
  (setf *catch-errors-p* nil
	*dispatch-table* (list (test-page "/apropos" 'web-apropos))))


