;; -*- mode: Lisp; Syntax: Common-Lisp; Package: cells; -*-
#|

    Hunchncells -- Cells, Parenscript, and HTML

Copyright (C) 2008 by Andy Chambers

This library is free software; you can redistribute it and/or
modify it under the terms of the Lisp Lesser GNU Public License
 (http://opensource.franz.com/preamble.html), known as the LLGPL.

This library is distributed  WITHOUT ANY WARRANTY; without even 
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the Lisp Lesser GNU Public License for more details.

|#

(in-package :hunchncells)

(defmacro param? (name)
  `(bif (req (request (fm-top self)))
	(get-parameter ,name req)))

(defun starts-with (str prefix)
  ;; (starts-with "ab" "a")
  ;; (starts-with "a" "a")
  ;; (starts-with "b" "a")
  (if (<= (length prefix) (length str))
      (equal (subseq str 0 (length prefix))
	     prefix)))

(defmodel web-app (family)
  ((prefix :initarg :prefix :accessor prefix :initform nil)
   (request :initarg :request :accessor request :initform nil)
   (message :initarg :message :accessor message :initform nil)
   (updates :initarg :updates 
	    :cell nil
	    :accessor updates 
	    :initform nil)
   (resource :initarg :resource
	     :owning t  ;; makes resource behave like a kid slot
	     :accessor resource 
	     :initform nil)
   (handler :initarg :handler :accessor handler :initform nil))
  (:default-initargs
      :prefix ""
    :request (c-in nil)
    :message (c-in nil)
;;     :updates (c? (mapcar 'xhtml
;; 			 (fm-collect-if (^resource)
;; 					(lambda (node)
;; 					  (print (list (id node)
;; 						       (dirtyp node)))
;; 					  (dirtyp node)))))

		   
    :handler (c? (bwhen (request (^request))
		   (let ((name (script-name request)))
		     (cond ((equal name (^prefix))
			    #'(lambda ()
				(fm-traverse (^resource) 'xuid)
				(print (^updates))
				(setf (^updates) nil)
				(xhtml (car (^resource)))))
			   ((starts-with name (^prefix))
			    #'(lambda ()
				(fm-traverse (^resource) 'xuid)
				(print (^updates))
				(setf (^updates) nil)
				(setf (content-type) "text/plain; charset=us-ascii")
				"list of updates"))))))))
;				(^updates)))))))))

(defmacro mk-web-app ((&rest rest) &body body)
  `(make-instance
    'web-app
    ,@rest
    :fm-parent nil
    :resource (c? (the-kids ,@body))))

;; (start-server :port 8080)

						 
		   
  
